use "fixed_1.dta", clear /*load and append all the files from the HPC*/
forvalues i=2/101{
	local name="fixed_"+"`i'"
	di  "`name'"
	append using "`name'"
}


gen id=_n
foreach method in "exact" "chi" "jointpearson"{
	di "`method'"
	sort theta Nsample id
	by theta Nsample: egen pmean`method'=mean(p`method')
	cap drop reject05
	gen reject05=0
	replace reject05=1 if p`method'<0.05
	cap drop preject`method'05
	by theta Nsample: egen preject`method'05=mean(reject05)
	cap drop reject10
	gen reject10=0
	replace reject10=1 if p`method'<0.1
	cap drop preject`method'10
	by theta Nsample: egen preject`method'10=mean(reject10)
	}
by theta Nsample:  gen  firstwinrates=1 if _n==1
keep if firstwinrates==1

*N=40
sort  Nsample theta
tw (line prejectexact05 theta, lcolor(black) yline(0.05, lpattern(dash)  lcolor(gs7) ) ) ///
(line prejectjointpearson05 theta, lcolor(green)) ///
(line prejectchi05 theta, lcolor(red)) if firstwinrates==1 & N==40 , ytitle("Probability of rejecting the null", size(5)) xtitle("Receiver's Mixture Probability on Left", size(5)) ///
 plotr(margin(zero)) graphregion(color(white)) legend(off) name(preject5,replace) 
graph export "Figure/PowerasWWsmall05_fixed.png", as(png)  wid(1200) hei(900) replace

tw (line prejectexact10 theta, lcolor(black) yline(0.1, lpattern(dash)  lcolor(gs7) ) ) ///
(line prejectjointpearson10 theta, lcolor(green)) ///
(line prejectchi10 theta, lcolor(red)) if firstwinrates==1 & N==40 , ytitle("Probability of rejecting the null", size(5)) xtitle("Receiver's Mixture Probability on Left", size(5)) ///
  xline(`x') plotr(margin(zero)) graphregion(color(white)) legend(off)name(preject10,replace)
graph export "Figure/PowerasWWsmall0_fixed.png", as(png) wid(1200) hei(900) replace

local x=2/3
sort theta Nsample
tw (line prejectexact05 theta, lcolor(black) yline(0.05, lpattern(dash)  lcolor(gs7) ) ) ///
 if firstwinrates==1 & N==7000,  ytitle("Probability of rejecting the null", size(5)) xtitle("Receiver's Mixture Probability on Left", size(5)) ///
 ylabel(0(0.2)1)  plotr(margin(zero)) graphregion(color(white)) legend(off) name(preject5,replace) 
graph export "Figure\PowerasWWlarge05_fixed.png", as(png) wid(1200) hei(900) replace

tw (line prejectexact10 theta, lcolor(black) yline(0.1, lpattern(dash)  lcolor(gs7) ) ) ///
if firstwinrates==1 & N==7000, ytitle("Probability of rejecting the null", size(4)) xtitle("Receiver's Mixture Probability on Left", size(4)) ///
 ylabel(0(0.2)1) plotr(margin(zero)) graphregion(color(white)) legend(off) name(preject10,replace)
graph export "Figure\PowerasWWlarge10_fixed.png", as(png) wid(1200) hei(900) replace

