* this code give the F stat for the run. It should be run on on result2.dta
* the formula can be found in the book: Gibbons, Dickson, Chakraborti "Nonparametric statistical inference". 1992
set varabbrev off
cap postclose myhandle
set more off

use "./data/pointgames.dta", clear

forvalues serve=1/2{
	cap drop r n1 n2
	gen	r=run`serve'
	gen	n1=servesL`serve'                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
	gen n2=servesR`serve'

	gen F`serve'run=0
	gen F`serve'runminus1=0

	cap drop A B C
	gen	A=0
	gen	B=0
	gen	C=0
		/* first we compute  Frun in the paper F(r_{i})*/
	sum r
	local maxrun=r(max)
	di `maxrun'
	cap drop fi
	gen fi=0
	*local maxrun=3
	forvalues k=2/`maxrun'{
		replace fi=0
		if ( mod(`k',2)==0 ) { /*k is even*/	
			di `k'
			replace fi=2*round(exp(lnfactorial(n1-1)))*round(exp(lnfactorial(n2-1)))*round(exp(lnfactorial(n1)))*round(exp(lnfactorial(n2))) ///
				/( ((round(exp(lnfactorial(`k'/2-1))))^2)*round(exp(lnfactorial(n1-`k'/2)))*round(exp(lnfactorial(n2-`k'/2)))*round(exp(lnfactorial(n1+n2))) ) ///
				if (n1-1)>=(`k'/2-1) & (n2-1)>=(`k'/2-1) /*we need that otherwise the binomial coeeficient are 0*/
		}
		if ( mod(`k',2)==1 ) { /*k is odd*/
		/*we decompose the formula in 3 (A+B)/C we do not develop the formula as we need to be careful because the binomial coefficient can be 0*/
			replace C=round(exp(lnfactorial(n1+n2)))/(round(exp(lnfactorial(n1)))*round(exp(lnfactorial(n2))))
			replace A=0
			replace A=round(exp(lnfactorial(n1-1)))*round(exp(lnfactorial(n2-1))) ///
				  /(round(exp(lnfactorial(`k'/2-1/2)))*round(exp(lnfactorial(n1-`k'/2-1/2)))*round(exp(lnfactorial(`k'/2-3/2)))*round(exp(lnfactorial(n2-`k'/2+1/2)))) ///
				  if ((n1-1)>=(`k'-1)/2 & (n2-1)>=(`k'-3)/2)
					  
			replace B=0
			replace	B=round(exp(lnfactorial(n1-1)))*round(exp(lnfactorial(n2-1))) ///
				/(round(exp(lnfactorial(`k'/2-3/2)))*round(exp(lnfactorial(n1-`k'/2+1/2)))*round(exp(lnfactorial(`k'/2-1/2)))*round(exp(lnfactorial(n2-`k'/2-1/2)))) ///
				if ((n1-1)>=(`k'-3)/2 & (n2-1)>=(`k'-1)/2)
			replace fi=(A+B)/C 
		}
		replace F`serve'run=F`serve'run+fi if `k'<=r & fi!=.
		replace F`serve'runminus1=F`serve'runminus1+fi if `k'<r & fi!=.
	}
	replace F`serve'run=1 if servesL`serve'==0 | servesR`serve'==0
	replace F`serve'runminus1=0 if servesL`serve'==0 | servesR`serve'==0
	cap drop t
	gen t`serve'=F`serve'runminus1+(F`serve'run -F`serve'runminus1)*runiform()
	* t is a realisation of a uniform([F(r-1), F(r)], so under H0 (choice direction iid) the t_{i} are distibuted U[(0 1)] 

	cap drop toomanyrun`serve'
	gen toomanyrun`serve'=0
	*replace toomanyrun`serve'=1 if 1-F`serve'runminus1<0.025
	replace toomanyrun`serve'=1 if t`serve'>0.975
	
	cap drop toofewrun`serve'  
	gen toofewrun`serve'=0
	replace toofewrun`serve'=1 if t`serve'<0.025

	
}
set more off
forvalues serve=1/2{
	foreach gender in "male" "female"{
		preserve
			keep if totalserves1>=10 & gender=="`gender'" 
			local name="run"+"`gender'"+"serve"+"`serve'"
			local namegraphcolor="Figure\"+"`name'"+"color.png"
			
			local Npoint=_N
			cap drop c
			cumul t`serve'  , gen(c)
			sort c
			ksmirnov t`serve'=t`serve'
			local KS:di%4.3f sqrt(_N)*r(D)
			di `KS'
			local p=r(p)
			if `p'> 0.001{
				local p:di%4.3f r(p)
			}
			if `p'<0.001{
				local p:di %10.3e r(p)
			}
			
			cap drop percenttoofewrun
			egen percenttoofewrun=total(toofewrun`serve')
			replace percenttoofewrun=percenttoofewrun/_N /**100*/
			local percenttoofewrun:di%4.3f percenttoofewrun[1]
			
			cap drop percenttoomanyrun
			egen percenttoomanyrun=total(toomanyrun`serve')
			replace percenttoomanyrun=percenttoomanyrun/_N /**100*/
			local percenttoomanyrun:di%4.2f percenttoomanyrun[1]
			
			count
			di "`serve'"
			di "`gender'"
			tab toofewrun`serve' 
			tab toomanyrun`serve'
			local min:di%4.3f r(min)
			local max:di%4.3f r(max)
			local mean:di%4.3f r(mean)
			local line1="KS="+"`KS'"
			local line2="p="+"`p'"
			local line3="G(0.025)="+"`percenttoofewrun'"
			local line4="1-G(0.975)="+"`percenttoomanyrun'"
			local Npoint: di%5.0fc `Npoint'
			local line5="N= "+"`Npoint'"
				
			tw (scatter c t`serve' , connect(stairstep) mlstyle(none) msize(vtiny) msymbol(i) lcolor(red)) ///
			(scatteri 0 0 1 1, lw(thin)  c(l) m(i) lcolor(blue) ), plotr(margin(zero)) name("`name'",replace)  graphregion(color(white)) legend(off) ///
			text(0.7 0.2 "`line1'" "`line2'"  "`line5'",  size(5) box  justification(left) bmargin(vlarge)  bcolor(white) width(40) height(15)   placement(12) )	
			graph export "`namegraphcolor'" , wid(1200) hei(900) as(png)  replace
			di "serve=""`serve'"
			di "gender=""`gender'"
			di "`line3'" 
			di "`line4'"
		restore
	}
}
