set varabbrev off
cap postclose myhandle
set more off
*ssc install egenmore (install the function egen corr() if not already installed*/

use "./data/Pointbypointforcorrelation.dta", clear
keep if totalserves1>=10
keep if serve==1

cap drop nextrightserve
sort idpointgame serve idinpointgame
by idpointgame serve: gen nextrightserve=rightserve[_n+1]
by idpointgame serve: egen correlation=corr(nextrightserve rightserve)
by idpointgame serve: replace correlation=1 if correlation==. /*When all serves are in the same direction we take the correlation coefficient to be one.*/

by idpointgame serve: keep if _n==1

foreach gender in "male" "female"{
	sum correlation if gender=="`gender'"
	local min:di%4.3f r(min)
	local max:di%4.3f r(max)
	local mean:di%4.3f r(mean)
	local Npoint=r(N)
	if `max'==1{
		local max:di%1.0f `max'
	}
	if `min'==-1{
		local min:di %1.0f `min'
	}
	local line1="min="+"`min'"
	local line2="max="+"`max'"
	local line3="mean="+"`mean'"
	local Npoint: di%5.0fc `Npoint'
	local line6="N= "+"`Npoint'"
	local width=0.01
	local x=0.5
	local y=2.2

	hist correlation if gender=="`gender'", ytitle("") yla(, labsize(*1.5)) xla(, labsize(*1.5)) graphregion(color(white)) legend(off) plotr(margin(zero)) w(`width') ///
	text(`y' `x'  "`line1'" "`line2'" "`line3'" "`line6'"  ,  ///
		size(7.5) box  justification(left) bmargin(vlarge)  bcolor(white) width(40) height(15)   placement(12) ) ///
		xtitle("") xlabel(-1(0.5)1)
	local name="Figure\histcorrelation"+"`gender'"+"1"+".png"
	graph export "`name'", as(png) width(1200) height(900) replace
}
