set varabbrev off
cap postclose myhandle
set more off

foreach i in 1 2{ /*first or second serves*/
	foreach gender in  "male" "female"{
		use "./data/pointgames.dta", clear
		keep if gender=="`gender'" & totalserves1>=10
		
		set more off	
		cap drop pointwon`i'
		gen pointwon`i'=pointwonL`i'+pointwonR`i'
		cap drop pointlost`i'
		gen pointlost`i'=totalserves`i'-pointwon`i'

		cap drop Fexact
		gen double  Fexact=0
		cap drop Fminus1exact
		gen double  Fminus1exact=0
		cap drop Ftotexact
		gen double  Ftotexact=0
		
		cap drop maxpointwon
		egen maxpointwon`i'=max(pointwon`i')
		local maxpointwon=maxpointwon`i'
		cap drop fi
		gen double fi=0
		
		cap drop A e f g h b c d a
		gen A=pointwonL`i'
		gen e=pointwon`i'
		gen f=pointlost`i'
		gen g=servesL`i'
		gen h=servesR`i'
		gen b=0
		cap drop c
		gen c=0
		gen d=0
		gen a=0
		forvalues a=0/`maxpointwon'{
		di `a'
		cap{
			replace fi=0
			replace a=`a'
			replace b=e-a if a<=g & h-e+a>=0
			replace c=g-a if a<=g & h-e+a>=0
			replace d=h-b if a<=g & h-e+a>=0
			*local tab="`a'"+","+"`b'"+"/"+"`c'"+","+"`d'"
			replace fi= round(exp(lnfactorial(e)),1)*round(exp(lnfactorial(f)),1)*round(exp(lnfactorial(g)),1)*round(exp(lnfactorial(h)),1) ///
				/(round(exp(lnfactorial(a)),1)*round(exp(lnfactorial(b)),1)*round(exp(lnfactorial(c)),1)*round(exp(lnfactorial(d)),1)*round(exp(lnfactorial(a+b+c+d)),1)) if a<=g & h-e+a>=0 
				replace Ftotexact=Ftotexact+fi if a<=g & h-e+a>=0 & fi!=.
				replace Fminus1exact=Fminus1exact+fi if a<=g & h-e+a>=0 & A>a & fi!=.
				replace Fexact=Fexact+fi if a<=g & h-e+a>=0 & A>=a & fi!=.
			}
		}

		cap drop texact
		gen texact=Fminus1exact+(Fexact-Fminus1exact)*runiform()

		cap drop c
		cumul texact, gen(c)
		sort c
		ksmirnov texact=texact 
		local KS=sqrt(_N)*r(D)
		local D=r(D)
		local Npointserve1=_N
		local Npointserve=_N
		if `Npointserve'>1000{
			local Npointserve2:di%5.0fc `Npointserve'
		}
		if `Npointserve'<1000{
			local Npointserve2:di%2.0fc `Npointserve'
		}
		local Dround:di%4.3f `D'
		di `KS'
		local KSround:di%4.3f `KS'
		local pvalsmirnov=r(p)
		di `pvalsmirnov'
		local pvalsmirnov:di%4.3f `pvalsmirnov'

		local N=_N+1
		set obs `N'
		replace texact = 1 if _n==_N
		replace c=1 if _n==_N
		local N=_N+1
		set obs `N'
		replace texact=0 if _n==_N
		replace c=0 if _n==_N
		sort texact c

		local line1="KS="+"`KSround'"
		local line2="D="+"`Dround'"
		local line3="p="+"`pvalsmirnov'"
		local line4="N="+"`Npointserve2'"
			
		local namegraph="Figure\Fexact"+"`gender'"+"`i'"+"color.png"
		tw (scatter  c texact, connect(stairstep ) m(none) color(red) ) (scatteri 0 0 1 1, lw(thin)  c(l) m(i) lcolor(blue) ), ///
		text(0.75 .3 "`line1'" "`line2'" "`line3'" "`line4'", size(5)  box  justification(left) bmargin(vlarge)  bcolor(white) width(40) height(15)   placement(12) ) ///
		graphregion(color(white)) legend(off) plotr(margin(zero)) name(data,replace) 
		graph export "`namegraph'" , wid(1200) hei(900)  as(png)   replace 
	}
}
