set varabbrev off
cap postclose myhandle
set more off

*select the colum for which we are doing the summary stat
local gender="male"
local i=1 /*1 or 2, first or second serves*/
local court="ad" /*ad or deuce court*/

use "./data/pointgames.dta", clear
keep if totalserves1>=10
keep if gender=="`gender'" & court=="`court'"

*Total number of serves
total totalserves`i' 
matrix B=e(b)
local Nservestot=B[1,1]

*Number of pointgames
count 
*Number of serves per pointgames 
sum totalserves`i' 

*Total number of serves on left (not in table)
total servesL`i'
matrix B=e(b)
local NservestotL=B[1,1]

*Proportion of serves on the Left (6th column)
di `NservestotL'/`Nservestot'

*Total number of serves on Right (not in table)
total servesR`i' 
matrix B=e(b)
local NservestotR=B[1,1]

*Proportion of serves on the Right (7th column)
di `NservestotR'/`Nservestot'

*Total number of point won on the Left (not in table)
total pointwonL`i'
matrix B=e(b)
local NwontotL=B[1,1]

*Proportion of serves won on the Left (8th column)
di `NwontotL'/`NservestotL'

*Total number of point won on the Right (not in table)
total pointwonR`i'
matrix B=e(b)
local NwontotR=B[1,1]

*Proportion of serves won on the Right (9th column)
di `NwontotR'/`NservestotR'
