set varabbrev off
cap postclose myhandle
set more off

cap postclose myhandle
postfile myhandle str10 gender j serve str6 server str6  receiver sumdiffsimul sumdiff sumXL sumXLsimul Dexact pexact N Ntot ///
 using "Results/Hiranotest", replace
forvalues i=1/2{ 
	foreach gender in "male" "female"{
		if "`gender'"=="male"{
			local median=22
		}
		if "`gender'"=="female"{
			local median=17
		}
		foreach server in "all"{
			foreach receiver in "top" "nontop" "all" "noranking"{
				di "gender=""`gender'"
				di "receiver=""`receiver'"
				di "serve=""`i'"
				use "C:\AAA_Tennis_project\Minimax\result2.dta", clear
					
				keep if totalserves1>=10 & gender=="`gender'"		
				if "`receiver'"=="top"{
					keep if rrank<=`median' &  rrank!=. & srank!=. /*important to have srank!=. because that what we used for the fisher exact test*/
				}
				if "`receiver'"=="nontop"{
					keep if rrank>`median' &  rrank!=. & srank!=.
				}
				if "`receiver'"=="noranking"{
					keep if rrank!=. & srank!=. 
				}
				local Ntot=_N

				*compute the stat for the dataset
				gen pL`i'=pointwonL`i'/servesL`i'
				gen pR`i'=pointwonR`i'/servesR`i'
				gen diff`i'=abs(pL`i'-pR`i')
				egen sumdiff=total(diff`i')
				sum sumdiff
				local sumdiff=r(mean)
				
				drop if diff`i'==.
				local N=_N
				
				cap drop EL
				gen EL=0
				gen ER=0
				
				*find the proba of each table
				cap drop pointwon`i'
				gen pointwon`i'=pointwonL`i'+pointwonR`i'
				cap drop pointlost`i'
				gen pointlost`i'=totalserves`i'-pointwon`i'
				gen A=pointwonL`i'
				gen e=pointwon`i'
				gen f=pointlost`i'
				gen g=servesL`i'
				gen h=servesR`i'
				gen b=0
				cap drop c
				gen c=0
				gen d=0
				gen a=0
				egen maxpointwon`i'=max(pointwon`i')
				local maxpointwon=maxpointwon`i'
				cap drop Fexact
				gen double  Fexact=0
				cap drop Fminus1exact
				gen double  Fminus1exact=0
				cap drop Ftotexact
				gen double  Ftotexact=0
				local maxpointwon=maxpointwon`i'
				cap drop fi
				gen double fi=0 /* fi is the proba of table i*/
				gen pointwonLsimul`i'=-1

				forvalues a=0/`maxpointwon'{
				
					replace a=`a'
					replace b=e-a if a<=g & h-e+a>=0
					replace c=g-a if a<=g & h-e+a>=0
					replace d=h-b if a<=g & h-e+a>=0
					*local tab="`a'"+","+"`b'"+"/"+"`c'"+","+"`d'"
					
					
					replace fi= round(exp(lnfactorial(e)),1)*round(exp(lnfactorial(f)),1)*round(exp(lnfactorial(g)),1)*round(exp(lnfactorial(h)),1) ///
						/(round(exp(lnfactorial(a)),1)*round(exp(lnfactorial(b)),1)*round(exp(lnfactorial(c)),1)*round(exp(lnfactorial(d)),1)*round(exp(lnfactorial(a+b+c+d)),1)) if a<=g & h-e+a>=0 
					replace Ftotexact=Ftotexact+fi if a<=g & h-e+a>=0 & fi!=.
					gen Ftotexact`a'=Ftotexact
					replace Fminus1exact=Fminus1exact+fi if a<=g & h-e+a>=0 & A>a & fi!=.
					replace Fexact=Fexact+fi if a<=g & h-e+a>=0 & A>=a & fi!=.
					
					replace EL=EL+fi*a if a<=g & h-e+a>=0 & fi!=.
					replace ER=ER+fi*b if a<=g & h-e+a>=0 & fi!=.
					
					gen f`a'=fi

				}
				cap drop XL
				gen XL=(pointwonL`i'-EL)^2
				cap drop sumXL
				egen sumXL=total(XL)
				sum sumXL
				local sumXL=r(mean)
				
				forvalues j=1/1000{
					if mod(`j',250)==0{
						di `j'
					}
					cap{
						cap drop table
						gen table=-1
						cap drop pointwonLsimul`i'
						gen pointwonLsimul`i'=-1
						cap drop u
						gen u=runiform() /*u randomnly choose which table we pick*/
						forvalues a=0/`maxpointwon'{	
							local aminus1=`a'-1
							if `a'==0 {
								replace pointwonLsimul`i'=`a' if  u<=Ftotexact`a'
								replace table=`a' if  u<=Ftotexact`a'
							}
							if `a'>0 {	
								replace pointwonLsimul`i'=`a' if u>=Ftotexact`aminus1' & u<=Ftotexact`a' & Ftotexact`a'!=. 
								replace table=`a' if u>=Ftotexact`aminus1' & u<=Ftotexact`a' & Ftotexact`a'!=. 
							}
						}
						cap drop pointwonRsimul`i'
						gen pointwonRsimul`i'=pointwon`i'-pointwonLsimul`i'
						cap drop pLsimul`i' pRsimul`i' diffsimul`i' sumdiffsimul`i'
						gen pLsimul`i'=pointwonLsimul`i'/servesL`i'
						gen pRsimul`i'=pointwonRsimul`i'/servesR`i'
						gen diffsimul`i'=abs(pLsimul`i'-pRsimul`i')
						egen sumdiffsimul`i'=total(diffsimul`i')
						sum sumdiffsimul`i'
						local sumdiffsimul=r(mean)
						
						cap drop XLsimul
						gen XLsimul=(pointwonLsimul`i'-EL)^2
						cap drop sumXLsimul
						egen sumXLsimul=total(XLsimul)
						sum sumXLsimul
						local sumXLsimul=r(mean)
						
						*texact (need to be within this loop to get 1,000 draw of it)
						cap drop texact
						gen texact=Fminus1exact+(Fexact-Fminus1exact)*runiform()
						cap drop c
						cumul texact, gen(c)
						sort c
						ksmirnov texact=texact 
						local KS=sqrt(_N)*r(D)
						local Dexact=r(D)
						local pexact=r(p)
					}
				post myhandle  ("`gender'") (`j') (`i') ("`server'") ("`receiver'") (`sumdiffsimul')  (`sumdiff') (`sumXL') (`sumXLsimul') (`Dexact') (`pexact') (`N') (`Ntot')		 		
				}
			}
		}
	}
}
postclose myhandle
use "Results/Hiranotest", clear

cap drop countaboveL
gen countaboveL=[sumXLsimul>sumXL]
sort gender serve server receiver
by gender serve server receiver: egen pXLabove=mean(countaboveL)
cap drop countbelow
gen countbelowL=[sumXLsimul<sumXL]
sort gender serve server receiver
by gender serve server receiver: egen pXLbelow=mean(countbelowL)
cap drop temp
gen temp=min(pXLabove,pXLbelow)
gen pXL=2*temp


cap drop countabovediff
gen countabovediff=[sumdiffsimul>sumdiff]
sort gender serve server receiver
by gender serve server receiver: egen pdiffabove=mean(countabovediff)
cap drop countbelowdiff
gen countbelowdiff=[sumdiffsimul<sumdiff]
sort gender serve server receiver
by gender serve server receiver: egen pdiffbelow=mean(countbelowdiff)
cap drop temp
gen temp=min(pdiffabove,pdiffbelow)
gen pdiff=2*temp

sort gender serve server receiver
ed gender serve  receiver pXL  pdiff if j==1
ed gender serve  receiver pdiff if j==1

*This is Table B1
ed gender serve server receiver sumdiff pdiff pexact N Ntot if j==1
